#!/usr/bin/env python
"""
"""
# Python 2.6 and newer support
from __future__ import (absolute_import, division,
                        print_function, unicode_literals)
from future.builtins import (
                bytes, dict, int, list, object, range, str,
                ascii, chr, hex, input, next, oct, open,
                pow, round, super,
                filter, map, zip)
try:
    unicode()
except NameError:
    unicode = str

import sys
__python_version__ = dict()
try:
    __python_version__['major'] = sys.version_info.major
except AttributeError:
    __python_version__['major'] = sys.version_info[0]
try:
    __python_version__['minor'] = sys.version_info.minor
except AttributeError:
    __python_version__['minor'] = sys.version_info[1]

import threading


class SharedResource(object):
    """Any resource that needs to be shared across threads. Provides mechanisms.
    """
    def __init__(self):
        object.__init__(self)
        self.__lock = threading.Lock()
        
    @property
    def lock(self):
        """The lock object for this shared resource instance.
        """
        return self.__lock

